// count.cpp
// --------- Version 17.07.2001, H. Knauff
//                   08.09.2001, D. Schwarzer
//                   08.03.2002, U. Sobotta
// Borland IDE Builder 4.0
// Model: SMALL
//  char: unsigned
//-------------------------------------------
// Hardware: standalone SC12@Chip / Nixie Anzeige
//           mit 2 PCF 8574 8 Bit Toradaptern
// Ausgabe von datenbytes an beide Tore, die als
// Lauflichter betrachtet werden koennen.

#pragma hdrstop
//#include <condefs.h>
#include <dos.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma argsused

#define i2cTOR0 0x74            // I2C Adresse von Tor #0
#define i2cTOR1 0x78            // I2C Adresse von Tor #1
//int a=0x00;
int i=0,a=0,z=0;
static union REGS inregs;
static union REGS outregs;

// API-Systemfunktionen
// --------------------
void sleep(unsigned time)
{
	inregs.h.ah = 0x09;
	inregs.x.bx = time;
	int86(0xAC,&inregs,&outregs);
}
// API - I2C- Funktionen
// ---------------------

void i2c_init(void)
{
	inregs.h.ah = 0x80;
	int86(0xAA,&inregs,&outregs);
}

void i2c_release(void)
{
	inregs.h.ah = 0x84;
	inregs.h.al = 0;
	int86(0xAA,&inregs,&outregs);
}

int i2c_transmit(char tor, char c)
{
	inregs.h.ah = 0x82;
	inregs.h.al = tor & 0xfe;
	inregs.h.cl = c;
	int86(0xAA,&inregs,&outregs);
	if(outregs.x.flags&0x01)
	{
		return (int)outregs.h.al & 0x00FF;
	}
	return 0;
}

// Ende der API

// Hauptprogramm
// Testprogramm zur Ausgabe von Datenbytes an die  I2C
// Tore #0 und #1

void main (void)
{
do
{
       int d=0x00;
	printf("\r\n i2c-count [Start]\r\n");

	i2c_init();             // I2C Bus initialisieren
	for (a=0;a<=3;a++)
	  {
	   i2c_transmit(i2cTOR0,0x02); // RESET
	   i2c_release();
	   if (a==0)
	   {
	   d=0xe0;
	   }
	   if (a==1)
	   {
	   d=0xb0;
	   }
	   if (a==2)
	   {
	   d=0x70;
	   }
	   if (a==3)
	   {
	   d=0x20;
	   }
		for (i=0;i<=154;i++)
		{
			if (i>=10 && i<=16)
			{
			i=i+6;
			}
			if (i>=26 && i<=32)
			{
			i=i+6;
			}
			if (i>=42 && i<=48)
			{
			i=i+6;
			}
			if (i>=58 && i<=64)
			{
			i=i+6;
			}if (i>=74 && i<=80)
			{
			i=i+6;
			}
			if (i>=90 && i<=96)
			{
			i=i+6;
			}if (i>=106 && i<=112)
			{
			i=i+6;
			}if (i>=122 && i<=128)
			{
			i=i+6;
			}
			if (i>=138 && i<=144)
			{
			i=i+6;
			}
			i2c_transmit(i2cTOR1,(i));
			i2c_release();
			//printf("Tor 1 auf %i",i);
			i2c_transmit(i2cTOR0,d);// Schicke Wert 'i' an Tor 0
			i2c_release();          // Bus freigeben
			//printf("\r\n Setze Tor 0 auf %i",d);
			sleep(100);
			i2c_transmit(i2cTOR0,0xff); // Schicke Wert '0xFF' an Tor 0
			i2c_release();          // Bus freigeben
			//printf("\r\n Wert: %i",(i));
			//sleep(1000);

			//sleep(1000);
			}
			//i2c_transmit(i2cTOR1,0x00); // Schicke Wert '0x00' an Tor 0
			//i2c_release();          // Bus freigeben

		//sleep(1000);

	  } //for
	 // z++;
	  printf("\r\n mache den %i turn",z);
	}
	while (z<=400);


	} // main
